# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class TeaserLegLegBetType(Enum):
    """An enumeration representing different categories.

    :cvar SPREAD: "SPREAD"
    :vartype SPREAD: str
    :cvar TOTAL_POINTS: "TOTAL_POINTS"
    :vartype TOTAL_POINTS: str
    """

    SPREAD = "SPREAD"
    TOTAL_POINTS = "TOTAL_POINTS"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, TeaserLegLegBetType._member_map_.values()))


class TeaserLegLegBetStatus(Enum):
    """An enumeration representing different categories.

    :cvar CANCELLED: "CANCELLED"
    :vartype CANCELLED: str
    :cvar LOST: "LOST"
    :vartype LOST: str
    :cvar PUSHED: "PUSHED"
    :vartype PUSHED: str
    :cvar REFUNDED: "REFUNDED"
    :vartype REFUNDED: str
    :cvar WON: "WON"
    :vartype WON: str
    """

    CANCELLED = "CANCELLED"
    LOST = "LOST"
    PUSHED = "PUSHED"
    REFUNDED = "REFUNDED"
    WON = "WON"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, TeaserLegLegBetStatus._member_map_.values()))


class TeaserLegSide(Enum):
    """An enumeration representing different categories.

    :cvar OVER: "OVER"
    :vartype OVER: str
    :cvar UNDER: "UNDER"
    :vartype UNDER: str
    """

    OVER = "OVER"
    UNDER = "UNDER"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, TeaserLegSide._member_map_.values()))


@JsonMap(
    {
        "sport_id": "sportId",
        "leg_bet_type": "legBetType",
        "leg_bet_status": "legBetStatus",
        "league_id": "leagueId",
        "event_id": "eventId",
        "event_start_time": "eventStartTime",
        "team_name": "teamName",
        "period_number": "periodNumber",
    }
)
class TeaserLeg(BaseModel):
    """TeaserLeg

    :param sport_id: sport_id, defaults to None
    :type sport_id: int, optional
    :param leg_bet_type: Teaser leg type., defaults to None
    :type leg_bet_type: TeaserLegLegBetType, optional
    :param leg_bet_status: CANCELLED = The leg is canceled- the stake on this leg will be transferred to the next one. In this case the leg will be ignored when calculating the winLoss,  <br>LOSE = The leg is a loss or a push-lose. When Push-lose happens, the half of the stake on the leg will be pushed to the next leg, and the other half will be a lose. This can happen only when the leg is placed on a quarter points handicap,  <br>PUSHED = The leg is a push - the stake on this leg will be transferred to the next one. In this case the leg will be ignored when calculating the winLoss,  <br>REFUNDED = The leg is refunded - the stake on this leg will be transferred to the next one. In this case the leg will be ignored when calculating the winLoss,  <br>WON = The leg is a won or a push-won. When Push-won happens, the half of the stake on the leg will be pushed to the next leg, and the other half is won. This can happen only when the leg is placed on a quarter points handicap  <br>, defaults to None
    :type leg_bet_status: TeaserLegLegBetStatus, optional
    :param league_id: league_id, defaults to None
    :type league_id: int, optional
    :param event_id: event_id, defaults to None
    :type event_id: int, optional
    :param event_start_time: Date time when the event starts., defaults to None
    :type event_start_time: str, optional
    :param handicap: handicap, defaults to None
    :type handicap: float, optional
    :param team_name: team_name, defaults to None
    :type team_name: str, optional
    :param side: Side type., defaults to None
    :type side: TeaserLegSide, optional
    :param team1: team1, defaults to None
    :type team1: str, optional
    :param team2: team2, defaults to None
    :type team2: str, optional
    :param period_number: period_number, defaults to None
    :type period_number: int, optional
    """

    def __init__(
        self,
        sport_id: int = None,
        leg_bet_type: TeaserLegLegBetType = None,
        leg_bet_status: TeaserLegLegBetStatus = None,
        league_id: int = None,
        event_id: int = None,
        event_start_time: str = None,
        handicap: float = None,
        team_name: str = None,
        side: TeaserLegSide = None,
        team1: str = None,
        team2: str = None,
        period_number: int = None,
    ):
        if sport_id is not None:
            self.sport_id = sport_id
        if leg_bet_type is not None:
            self.leg_bet_type = self._enum_matching(
                leg_bet_type, TeaserLegLegBetType.list(), "leg_bet_type"
            )
        if leg_bet_status is not None:
            self.leg_bet_status = self._enum_matching(
                leg_bet_status, TeaserLegLegBetStatus.list(), "leg_bet_status"
            )
        if league_id is not None:
            self.league_id = league_id
        if event_id is not None:
            self.event_id = event_id
        if event_start_time is not None:
            self.event_start_time = event_start_time
        if handicap is not None:
            self.handicap = handicap
        if team_name is not None:
            self.team_name = team_name
        if side is not None:
            self.side = self._enum_matching(side, TeaserLegSide.list(), "side")
        if team1 is not None:
            self.team1 = team1
        if team2 is not None:
            self.team2 = team2
        if period_number is not None:
            self.period_number = period_number
